/**************************************************************************

  =======================
  The Voyager Web Browser
  =======================

  Copyright (C) 1995-2001 by
   Oliver Wagner <owagner@vapor.com>
   All Rights Reserved

  Parts Copyright (C) by
   David Gerber <zapek@vapor.com>
   Jon Bright <jon@siliconcircus.com>
   Matt Sealey <neko@vapor.com>

**************************************************************************/


#ifndef VOYAGER_MENUS_H
#define VOYAGER_MENUS_H
/*
 * $Id: menus.h,v 1.14 2003/04/25 19:13:55 zapek Exp $
*/

/*
 * "Intuition" menus
 */
extern APTR menu;


/*
 * Context menu types
 */
enum {
	VMT_PAGEMODE,
	VMT_LINKMODE,
	VMT_IMAGEMODE,
	VMT_IMAGELINKMODE
};

#define VMT_NUM 4 /* number of types */

/*
 * Helper macros
 */
enum {
	MODE_LABELS,
	MODE_ACTION,
	MODE_ARGS,
	MODE_DEPTH
};


/*
 * Intuition Menu IDs
 */
enum {
	MENU_dummy = 5000,
	MENU_ABOUT,
	MENU_CACHE,
	MENU_NETINFO,
	MENU_DOWNLOADS,
	MENU_ICONIFY,
	MENU_QUIT,
	MENU_MUIOPTS,
	MENU_REXX,

	MENU_CACHECONTENTS,
	MENU_EDIT,

	MENU_CACHEFLUSH,
	MENU_CACHEFLUSHIMAGES,

	MENU_WINDOWS,
	MENU_WIN_NEW,
	MENU_WIN_CLOSE,
	MENU_WIN_SAVE,
	MENU_WIN_PRINT,
	MENU_WIN_SOURCE,
	MENU_WIN_DOCINFOWIN,
	MENU_WIN_FIND,

	MENU_GOTO_HOME,

	MENU_SET_NET,
	MENU_SET_MIME,
	MENU_SET_GUI,
	MENU_SET_MAILNEWS,
	MENU_SET_USEBACKGROUND,
	MENU_SET_LOADIMAGES,
	MENU_SET_LOADIMAGES_ALL,
	MENU_SET_LOADIMAGES_IMAPS,
	MENU_SET_LOADIMAGES_NONE,
	MENU_SET_LOADIMAGES_BACKGROUNDS,
	MENU_SET_obsolete,
	MENU_SET_NOPROXY,
	MENU_SET_IGNOREFRAMES,
	MENU_SET_SPOOF_0,
	MENU_SET_SPOOF_1,
	MENU_SET_SPOOF_2,
	MENU_SET_SPOOF_3,
	MENU_SET_LOAD,
	MENU_SET_SAVE,
	MENU_SET_SAVEAS,
	MENU_SET_SAVEASDEF,
	MENU_SET_KEEPFTP,
	MENU_SET_IGNOREMIME,
	MENU_SET_PLUGINS,

	MENU_SAVEHTML,
	MENU_SAVETEXT,
	MENU_OPENFILE,

	MENU_BM_GOTO,
	MENU_BM_SAVE,
	MENU_BM_SAVEAS,
	MENU_BM_LOAD,
	MENU_BM_SAVEASDEF,
	MENU_BM_SEARCH,

	MENU_BM_IMPORT_VOYAGER,
	MENU_BM_IMPORT_IBROWSE,
	MENU_BM_IMPORT_AWEB,

	MENU_BM_EXPORT_WWW,
	MENU_BM_EXPORT_FTP,
	MENU_BM_EXPORT_WWW_AND_FTP,

	MENU_ABOUTMUI,
	MENU_SET_METAREFRESH,
	MENU_CACHEPRUNE,
	MENU_SET_OFFLINEMODE,

	MENU_JSSNOOP,
	MENU_COOKIEBROWSER,
	MENU_AUTHBROWSER,

	MENU_SETWINSIZE,
	MENU_SETWINSIZE_1,
	MENU_SETWINSIZE_2,
	MENU_SETWINSIZE_3,
	MENU_SETWINSIZE_FS,

	MENU_ERRORWIN,

#ifdef VDEBUG
	MENU_SET_DEBUG_HTML,
	MENU_SET_DEBUG_CSS,
	MENU_SET_DEBUG_AUTH,
	MENU_SET_DEBUG_CACHE,
	MENU_SET_DEBUG_COOKIE,
	MENU_SET_DEBUG_DNS,
	MENU_SET_DEBUG_DOCINFOWIN,
	MENU_SET_DEBUG_DOWNLOADWIN,
	MENU_SET_DEBUG_FTP,
	MENU_SET_DEBUG_HISTORY,
	MENU_SET_DEBUG_HTTP,
	MENU_SET_DEBUG_JS,
	MENU_SET_DEBUG_NET,
	MENU_SET_DEBUG_PLUGIN,
	MENU_SET_DEBUG_MAIL,
	MENU_SET_DEBUG_CACHEPRUNE,
	MENU_SET_DEBUG_GUI,
	MENU_SET_DEBUG_MISC,
	MENU_SET_DEBUG_INIT,
	MENU_SET_DEBUG_FORCEBORDER,
	MENU_SET_DEBUG_REXX,
	MENU_SET_DEBUG_IMGDEC,

	MENU_SET_DEBUG_LEVEL_0,
	MENU_SET_DEBUG_LEVEL_1,
	MENU_SET_DEBUG_LEVEL_2,
	MENU_SET_DEBUG_LEVEL_3,
	MENU_SET_DEBUG_LEVEL_4,

#endif /* VDEBUG */

	MENU_BM = 10000,
	MENU_BM_EDIT,
	MENU_BM_LIST
};

/*
 * Protos
 */
APTR build_context_menu( int mode, APTR obj, ULONG *split1 );

#endif /* VOYAGER_MENUS_H */
